#include <netinet/in.h>
#include <pcap.h>

#define SNAPLEN     1500
#define TIMEOUT      100
#define SNARF         -1

#define IPV4      0x0800
#define EH            14

sockaddr_in *sockmap[65535];
struct pcap_t *Pcapt;

void handle_tcpv4(struct ip iphdr, unsigned char *data)
{
	struct tcphdr tcp;

	tcp.th_sport = ((struct tcphdr *)(data+EH+(iphdr.ip_hl*4)))->th_sport;
	tcp.th_dport = ((struct tcphdr *)(data+FRAME_HEADER_LENGTH+(iphdr.ip_hl*4)))->th_dport;
	tcp.th_seq = ((struct tcphdr *)(data+FRAME_HEADER_LENGTH+(iphdr.ip_hl*4)))->th_seq;
	tcp.th_ack = ((struct tcphdr *)(data+FRAME_HEADER_LENGTH+(iphdr.ip_hl*4)))->th_ack;
	tcp.th_x2 = ((struct tcphdr *)(data+FRAME_HEADER_LENGTH+(iphdr.ip_hl*4)))->th_x2;
	tcp.th_off = ((struct tcphdr *)(data+FRAME_HEADER_LENGTH+(iphdr.ip_hl*4)))->th_off;
	tcp.th_flags = ((struct tcphdr *)(data+FRAME_HEADER_LENGTH+(iphdr.ip_hl*4)))->th_flags;
	tcp.th_win = ((struct tcphdr *)(data+FRAME_HEADER_LENGTH+(iphdr.ip_hl*4)))->th_win;
	tcp.th_sum = ((struct tcphdr *)(data+FRAME_HEADER_LENGTH+(iphdr.ip_hl*4)))->th_sum;
	tcp.th_urp = ((struct tcphdr *)(data+FRAME_HEADER_LENGTH+(iphdr.ip_hl*4)))->th_urp;


}

void handle_ipv4(unsigned char *data)
{
	struct ip iphdr;

	iphdr.ip_v   = ((struct ip *)(data+EH))->ip_v;   /* version */
	iphdr.ip_hl  = ((struct ip *)(data+EH))->ip_hl; /* # of 32bit words in hdr */
	iphdr.ip_tos = ((struct ip *)(data+EH))->ip_tos; /* type of service */
	iphdr.ip_len = ((struct ip *)(data+EH))->ip_len; /* total length */
	iphdr.ip_id  = ((struct ip *)(data+EH))->ip_id;  /* id */
	iphdr.ip_off = ((struct ip *)(data+EH))->ip_off; /* offset to data */
	iphdr.ip_ttl = ((struct ip *)(data+EH))->ip_ttl; /* time to live */
	iphdr.ip_p   = ((struct ip *)(data+EH))->ip_p;   /* protocol carried */
	iphdr.ip_csum= ((struct ip *)(data+EH))->ip_csum;/* Checksum */
	iphdr.ip_src = ((struct ip *)(data+EH))->ip_src; /* in_addr */
	iphdr.ip_dst = ((struct ip *)(data+EH))->ip_dst; /* in_addr */

	switch( iphdr.ip_p )
	{
		case IP_TCP: handle_tcpv4(iphdr, data);
			break;
		default:
			break;
	}
}

void handler(unsigned char *buf1, struct pcap_pkthdr *pkthdr, unsigned char *data)
{
	unsigned short proto = ntohs(((struct ethhdr *)data)->h_proto);

	switch(proto)
	{
		case IPV4: handle_ipv4(data);
			break;
		default:
			break;
	}
}

void deal_masq()
{
	char *device;
	char *errormsg;
	unsigned long number;

	if( (struct pcap *)Pcapt = pcap_open_live(device, SNAPLEN, 1, TIMEOUT, errormsg)) == NULL)
	{
		pcap_error( (struct pcap *)Pcapt, "open_live");
		return;
	}

	number = pcap_loop( (struct pcap *)Pcapt, SNARF, (pcap_handler)handler, user);

	pcap_close( (struct pcap *)Pcapt );
}
